Bug 1718369

Summary: znc fails to build with Python 3.8
Product: [Fedora] Fedora Reporter: Petr Viktorin <pviktori>
Component: zncAssignee: Nick Bebout <nb>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: high Docs Contact:
Priority: unspecified    
Version: rawhideCC: mhroncok, nb, nick, rosset.filipe
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: znc-1.7.5-1.fc31 znc-1.7.5-1.fc30 znc-1.7.5-1.fc29 znc-1.7.5-1.el7 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2019-10-07 00:01:39 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On:    
Bug Blocks: 1750908, 1750909, 1686977    

Description Petr Viktorin 2019-06-07 14:49:49 UTC
znc fails to build with Python 3.8.0b1.

The build cannot find Python API, Py_Initialize, because linker flags no longer contain libpython.
Code that embeds Python (rather than building an extension module) needs to pass `--embed` to any `python3-config --libs` invocation to build with Python 3.8.
More information: 
https://docs.python.org/3.8/whatsnew/3.8.html#debug-build-uses-the-same-abi-as-release-build

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.8/fedora-rawhide-x86_64/00927094-znc/

For all our attempts to build znc with Python 3.8, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.8/package/znc/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.8:
https://copr.fedorainfracloud.org/coprs/g/python/python3.8/

Let us know here if you have any questions.

Comment 1 Miro Hrončok 2019-07-10 15:11:50 UTC
Nick?

Comment 2 Nicholas E. Bebout 2019-07-15 20:03:58 UTC
I'll try to look at it this week, or if someone would like to send a patch that would be awesome.

Comment 3 Filipe Rosset 2019-07-21 02:24:47 UTC
Opened upstream issue https://github.com/znc/znc/issues/1675

Comment 4 Nicholas E. Bebout 2019-07-24 15:46:17 UTC
Looks like it will be fixed with the next release of ZNC.

Comment 5 Filipe Rosset 2019-07-24 17:47:38 UTC
(In reply to Nicholas E. Bebout from comment #4)
> Looks like it will be fixed with the next release of ZNC.

I'm not sure, yesterday I downloaded the patch and tried to build 1.7.4 against py3.8 from Koji, no luck :(

Comment 6 Ben Cotton 2019-08-13 16:47:01 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 7 Miro Hrončok 2019-08-14 22:24:07 UTC
The coordinated rebuild of Python 3.8 has started in the `f32-python` side tag.

If you figure out how to rebuild this package, please don't rebuild it in regular rawhide, but use the side tag instead:

    on branch master:
    $ fedpkg build --target=f32-python

To wait for a build to show up in the side tag, do:

    $ koji wait-repo f32-python --build=<nvr>

Where <nvr> is name-version-release of the source package, e.g. python-foo-1.1-2.fc32.

An updated mock config is posted at:
http://copr.fedorainfracloud.org/coprs/g/python/python3.8/

Note that it will take a while before the essential packages are rebuilt, so don't expect all your dependencies to be available right away.

Thanks. Let us know if you need up to date info, or if you have any questions.



PS this message is mass posted to all the bugs that block the PYTHON38 bug. If this is also a Fedora 31 FTBFS bug and you manage to fix it, you can do a f31 build as usual:

    on branch f31:
    $ fedpkg build

Comment 8 Miro Hrončok 2019-08-21 16:34:22 UTC
The f32-python side tag has been merged. In order to rebuild the package, do it in regular rawhide, but please wait until python3-3.8 is tagged:

  $ koji wait-repo f32-build --build python3-3.8.0~b3-3.fc32


If your built already started in f32-python, after it is finished, please tag it to rawhide with:

  $ koji tag-build f32-pending <nvr>

For example:

  $ koji tag-build f32-pending libreoffice-6.3.0.4-3.fc32

Thanks!

(This comment is mass posted to all bugzillas blocking the PYTHON38 tracking bug.)

Comment 9 Miro Hrončok 2019-08-21 17:28:58 UTC
(Python 3.8 has landed in the rawhide buildroot.)

Comment 10 Miro Hrončok 2019-09-16 08:41:11 UTC
This issue is blocking the Python 3.8 rebuilds. If this package won't build with 3.8, it won't be installable, along with all its dependent packages, in Fedora 32.
Furthermore, as it fails to install, its dependent packages will fail to install and/or build as well.

Could you please look into this?

Comment 11 Nick Bebout 2019-09-23 13:39:11 UTC
This is fixed in 1.7.5-rc1 which I am currently building for rawhide

Comment 12 Fedora Update System 2019-09-28 15:01:00 UTC
FEDORA-2019-233d9b9a5e has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-233d9b9a5e

Comment 13 Fedora Update System 2019-09-28 15:01:06 UTC
FEDORA-2019-0e70ef9cbb has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-0e70ef9cbb

Comment 14 Fedora Update System 2019-09-28 15:01:08 UTC
FEDORA-EPEL-2019-eff0269a65 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-eff0269a65

Comment 15 Fedora Update System 2019-09-29 01:11:29 UTC
znc-1.7.5-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-233d9b9a5e

Comment 16 Fedora Update System 2019-09-29 01:47:53 UTC
znc-1.7.5-1.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-0e70ef9cbb

Comment 17 Fedora Update System 2019-09-29 02:36:27 UTC
znc-1.7.5-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-eff0269a65

Comment 18 Fedora Update System 2019-09-29 03:57:33 UTC
znc-1.7.5-1.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-f7c7c49df4

Comment 19 Fedora Update System 2019-10-07 00:01:39 UTC
znc-1.7.5-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 20 Fedora Update System 2019-10-07 00:54:09 UTC
znc-1.7.5-1.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2019-10-07 01:36:09 UTC
znc-1.7.5-1.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2019-10-14 16:02:12 UTC
znc-1.7.5-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.